/*
  Replacement for the 'engine.asm' for Borland C++ for Linux
*/

#include "base.h"
#include "_fastgl.h"

unsigned *set_bank_proc, set_vga_banking, clip_result;

extern "C" unsigned long long _rdtsc(void);

unsigned long long _rdtsc(void)
{
	asm rdtsc;
}

int test_mmx(void)
{
	return 0;	// not supported
}

void set_mmx(void)
{
}

void reset_mmx(void)
{
}

/*
void outpb(unsigned port, unsigned val)
{
	asm
	{
		movzx edx,word ptr [port]
		movzx eax,word ptr [val]
		out dx,al
	}
}

void outpw(unsigned port, unsigned val)
{
	asm
	{
		movzx edx,word ptr [port]
		movzx eax,word ptr [val]
		out dx,ax
	}
}

void outpl(unsigned port, unsigned val)
{
	asm
	{
		movzx edx,word ptr [port]
		movzx eax,word ptr [val]
		out dx,eax
	}
}

unsigned char inpb(unsigned port)
{
	asm
	{
		xor eax,eax
		movzx edx,word ptr [port]
		in al,dx
	}
}

unsigned short inpw(unsigned port)
{
	asm
	{
		xor eax,eax
		movzx edx,word ptr [port]
		in ax,dx
	}
}

unsigned int inpl(unsigned port)
{
	asm
	{
		xor eax,eax
		movzx edx,word ptr [port]
		in eax,dx
	}
}

*/

void outpb(unsigned port, unsigned val)
{
#ifdef __BORLANDC__
	asm
	{
		mov   edx,dword ptr [port]
		movzx eax,byte  ptr [val]
		out dx,al
	}
#endif
#ifdef __GNUC__
	__asm__ __volatile__ ("outb %%al,%%dx": :"d" (port), "a" (val));
#endif
}

void outpw(unsigned port, unsigned val)
{
#ifdef __BORLANDC__
	asm
	{
		mov   edx,dword ptr [port]
		movzx eax,word  ptr [val]
		out dx,ax
	}
#endif
#ifdef __GNUC__
	__asm__ __volatile__ ("outw %%ax,%%dx": :"d" (port), "a" (val));
#endif
}

void outpl(unsigned port, unsigned val)
{
#ifdef __BORLANDC__
	asm
	{
		mov edx,dword ptr [port]
		mov eax,dword ptr [val]
		out dx,eax
	}
#endif
#ifdef __GNUC__
	__asm__ __volatile__ ("outl %%eax,%%dx": :"d" (port), "a" (val));
#endif
}

unsigned char inpb(unsigned port)
{
	unsigned char input;
#ifdef __BORLANDC__
	asm
	{
		xor eax,eax
		mov edx,dword ptr [port]
		in  al,dx
		mov [input],al
	}
#endif
#ifdef __GNUC__
	__asm__ __volatile__ ("inb %%dx,%%al\n"
							: "=a" (input)
							: "d" (port));
#endif
	return input;
}

unsigned short inpw(unsigned port)
{
	unsigned short input;
#ifdef __BORLANDC__
	asm
	{
		xor eax,eax
		mov edx,dword ptr [port]
		in  ax,dx
		mov [input],ax
	}
#endif
#ifdef __GNUC__
	__asm__ __volatile__ ("inw %%dx,%%ax\n"
							: "=a" (input)
							: "d" (port));
#endif
	return input;
}

unsigned int inpl(unsigned port)
{
	unsigned int input;
#ifdef __BORLANDC__
	asm
	{
		xor eax,eax
		mov edx,dword ptr [port]
		in  eax,dx
		mov [input],eax
	}
#endif
#ifdef __GNUC__
	__asm__ __volatile__ ("inl %%dx,%%eax\n"
							: "=a" (input)
							: "d" (port));
#endif
	return input;
}

void modify_point2(FGPixel *ptr)
{
	FGPixel c = _CurrColor;
	switch (ppop)
	{
		default:
		case 0:
			*ptr =	c;
			break;
		case 1:					// xor
			*ptr^= c;
			break;
		case 2:					// and
			*ptr &= c;
			break;
		case 3:					// or
			*ptr |= c;
			break;
		case 4:					// plus
			*ptr += c;
			break;
		case 5:					// minus
			*ptr -= c;
			break;
		case 6:					// not
			*ptr ^= -1;
			break;
		case 7:					// not
			if (*ptr>=16) *ptr = c;
			break;
		case 8:					// transp
			if (c) *ptr = c;
			break;
	}
}

void modify_point(FGPixel *ptr, FGPixel c)
{
	switch (ppop)
	{
		default:
		case 0:
			*ptr =	c;
			break;
		case 1:					// xor
			*ptr^= c;
			break;
		case 2:					// and
			*ptr &= c;
			break;
		case 3:					// or
			*ptr |= c;
			break;
		case 4:					// plus
			*ptr += c;
			break;
		case 5:					// minus
			*ptr -= c;
			break;
		case 6:					// not
			*ptr ^= -1;
			break;
		case 7:					// not
			if (*ptr>=16) *ptr = c;
			break;
		case 8:					// transp
			if (c) *ptr = c;
			break;
	}
}

void L1RamToRam(FGPixel *from,	FGPixel *to, int w, int h, int off1, int off2)
{
	int step1 =	off1+w;
	int step2 =	off2+w;
	for(int i=0; i<h; i++)
	{
		FGmemcpy(to,from,w);
		from += step2;
		to += step1;
	}
}

//
// NOTE! this runs with pixels not bytes !!!
//
inline void FGmemcpyd(FGPixel * to, FGPixel* from, unsigned c)
{
	while (c--)
		*to-- = *from--;
}

void L1RamToRamd(FGPixel *from,	FGPixel *to, int w, int h, int step_src, int step_dst)
{
	for(int i=0; i<h; i++)
	{
		FGmemcpyd(to,from,w);
		from -= step_src;
		to -= step_dst;
	}
}

void L1RamToRamPpop(FGPixel *from,	FGPixel *to, int w, int h, int off1, int off2)
{
	int step1 =	off1+w;
	int step2 =	off2+w;
	for(int i=0; i<h; i++)
	{
		FGmemcpy2(to,from,w);
		from += step2;
		to += step1;
	}
}

// fill box in buffer without drawmode
void L1Box(FGPixel	*ptr, int w, int h, int xoffset)
{
	xoffset += w;
	for(;h>0;h--)
	{
		FGmemset(ptr, _CurrColor, w);
		ptr += xoffset;
	}
}

void L1BoxX(FGPixel	*ptr, int w, int h, int xoffset)
{
	xoffset += w;
	for(;h>0;h--)
	{
		FGmemset2(ptr, _CurrColor, w); // !!!!!!!!!!!!!!
		ptr += xoffset;
	}
}

// copy block from video to RAM
void L1VideoToRam8(FGPixel	*from, FGPixel	*to, int w, int h, int off1, int off2)
{
	off1 += w;
	off2 += w;
	for(;h>0;h--)
	{
		FGmemcpy(to, from, w); // !!!!!!!!!!!!!!
		from += off2;
		to += off1;
	}
}

void L1RamToVideo8(FGPixel	*from, FGPixel *to, int w,	int h, int off1, int off2)
{
	off1 += w;
	off2 += w;
	for(;h>0;h--)
	{
		FGmemcpy(to, from, w); // !!!!!!!!!!!!!!
		from += off1;
		to += off2;
	}
}

void L1RamToVideo2(FGPixel	*from, FGPixel *to, int w,	int h, int off1, int off2)
{
	off1 += w;
	off2 += w;
	for(;h>0;h--)
	{
		FGmemcpy2(to, from, w); // !!!!!!!!!!!!!!
		from += off1;
		to += off2;
	}
}

int set_ppop(int val)
{
	int tmp = ppop;
	ppop = val;
	return tmp;
}

void draw_hline(int x, int y, int len, FGPixel ink, unsigned ppop)
{
//	if (ppop) FGmemset2(videobase + X_width * y + x, _CurrColor, len);
//	else FGmemset(videobase + X_width * y + x, _CurrColor, len);
	draw_line(x,y,x+len,y, ink,  ppop);
}

void draw_vline(int x, int y, int len, FGPixel ink, unsigned ppop)
{
//	for(;len>0;len--) draw_point(x,y++);
	draw_line(x,y,x,y+len, ink, ppop);
}

void __fill_box(int x, int y, int w, int h, FGPixel ink, unsigned ppop)
{
	assert(lfb); // this is not permitted without linear addressing
	for(;h>0;h--) draw_hline(x,y++,w, ink,ppop);
}

void __draw_point(int x, int y, FGPixel ink, unsigned ppop)
{
	if (y <	clip_y_min || x < clip_x_min || y >= clip_y_max || x >= clip_x_max) return;
	modify_point2(videobase + X_width * y + x);
}

int get_point(int x, int y)
{
	if (y <	clip_y_min || x < clip_x_min || y >= clip_y_max || x >= clip_x_max) return 256;
	return *(videobase + X_width * y + x);
}

//
// NOTE! this runs with pixels not bytes !!!
//
void FGmemset2(FGPixel * to, FGPixel data, unsigned c)
{
	while (c--)
//		*to++ = data;
		modify_point(to++, data);
}


//
// NOTE! this runs with pixels not bytes !!!
//
void FGmemcpy(FGPixel * to, FGPixel* from, unsigned c)
{
	while (c--)
		*to++ = *from++;
}

//
// NOTE! this runs with pixels not bytes !!!
//
void FGmemcpy2(FGPixel * to, FGPixel* from, unsigned c)
{
	while (c--)
//		*to++ = *from++;
		modify_point(to++, *from++);
}

FGPixel LoadColor(FGPixel *p)
{
        asm
        {
           mov eax, [p]
							cmp [bpp],1
                                jz   LC8
                                cmp [bpp],2
                                jz   LC16
                                jmp  LC32
LC8:			mov		al,[eax]
				mov		ah,al
				push	ax
				push	ax
				pop		eax
				jmp end
LC16:			mov		ax,[eax]
			push	ax
				push	ax
				pop		eax
				jmp end
LC32:			mov		eax,[eax]
end:

        };
}

void CharOutClip(FGPixel *dst, FGPixel *src, int step, int w, int h)
{
        asm {
  add esp,3*4
  pop ebp
          cmp		byte [esp+16], 8
				jnz		_CharOutClip12
				cmp		byte [bpp], 1
				jnz		_CharOutClip12
				mov		edx,[esp+8]
				mov		eax,[esp+4]
				push	edi
				push	esi
				push	ebx
				push	ecx
				push	ebp
				cld
				mov		edi,eax
				mov		esi,edx
                                mov		ecx,[esp+(20+5*4)]
				xchg	eax,ebx
				mov		al,byte[_CurrColor]
				mov		ah,al
				push	ax
				push	ax
				pop		eax
				xchg	eax,ebx
				xchg	eax,edx
				mov		al,byte[_CurrBkColor]
				mov		ah,al
				push	ax
				push	ax
				pop		eax
				xchg	eax,edx
				push	ds
				pop		es
L127:			push	ecx
				push	edi
				lodsd
				mov		ebp,eax
				and		eax,ebx
				xchg	eax,ebp
				not		eax
				and		eax,edx
				or		eax,ebp
				stosd
				lodsd
				mov		ebp,eax
				and		eax,ebx
				xchg	eax,ebp
				not		eax
				and		eax,edx
				or		eax,ebp
				stosd
				pop		edi
				add		edi,[esp+36]
				pop		ecx
				dec		ecx
				jnz		L127
L127_1:			pop		ebp
				pop		ecx
				pop		ebx
				pop		esi
				pop		edi
				ret

_CharOutClip12:	mov		edx,[esp+8]
				mov		eax,[esp+4]
				push	edi
				push	esi
				push	ebx
				push	ecx
				push	ebp
				mov		cl,byte[bpp]
				shr		cl,1
				shl		dword [esp+32],cl
				cld
				mov		edi,eax
				mov		esi,edx
				xchg	eax,ebx
				push offset _CurrColor
                call LoadColor
				xchg	eax,ebx
				xchg	eax,edx
				push	offset _CurrBkColor
                call LoadColor
                add esp,2*4
				xchg	eax,edx
				push	ds
				pop		es
				mov		ecx,[esp+(20+5*4)]
				mov		eax,[esp+(16+5*4)]
                                push	edx
				mul		word [bpp]
				pop		edx
				shr		al,2
				mov		ch,al

L12712:			push	ecx
				push	edi
L12713:			lodsd
				mov		ebp,eax
				and		eax,ebx
				xchg	eax,ebp
				not		eax
				and		eax,edx
				or		eax,ebp
				stosd
				dec		ch
				jnz		L12713
				pop		edi
				pop		ecx
				add		edi,[esp+32]
				dec		cl
				jnz		L12712

       			pop		ebp
				pop		ecx
				pop		ebx
				pop		esi
				pop		edi
				ret
		};
}


void _degraduj(FGPixel *, FGPixel *, FGPixel *, int)
{
	asm {
  add esp,3*4
  pop ebp
				push	edi
				push 	esi
				push 	ecx
				push 	ebx
				mov		edi,[esp+20]
				mov		esi,[esp+24]
				mov		ecx,[esp+28]
				mov		ebx,[esp+32]

degraduj2:		mov		eax,[edi]
				mov		edx,[esi]
				push	ebx
				mov		ebx,eax
				and		ebx,0xF0F0F0F0
				test	eax,eax
				jz		nieje2
				and		al,0x0F
				jz		byte2
				dec		al
				or		al,bl
				or		dl,dl
				jnz		byte2
				mov		dl,al
byte2:			and		ah,0x0F
				jz		byte3
				dec		ah
				or		ah,bh
				or		dh,dh
				jnz		byte3
				mov		dh,ah
byte3:			rol		eax,16
				rol		edx,16
				rol		ebx,16
				and		al,0x0F
				jz		byte4
				dec		al
				or		al,bl
				or		dl,dl
				jnz		byte4
				mov		dl,al
byte4:			and		ah,0x0F
				jz		byte5
				dec		ah
				or		ah,bh
				or		dh,dh
				jnz		byte5
				mov		dh,ah
byte5:			rol		edx,16
				rol		eax,16
nieje2:			mov		[ecx],edx
				mov		[edi],eax
				add		edi,4
				add		esi,4
				add		ecx,4
				pop		ebx
				dec		ebx
				jnz		degraduj2
				pop		ebx
				pop		ecx
				pop		esi
				pop		edi
				ret
	}
}

void _scitaj(FGPixel *, FGPixel *, FGPixel *, int)
{
	asm {
  add esp,3*4
  pop ebp
				push	edi
				push 	esi
				push 	ecx
				push 	ebx
				mov		edi,[esp+20]
				mov		esi,[esp+24]
				mov		ecx,[esp+28]
				mov		ebx,[esp+32]

_degraduj2:			mov		eax,[edi]
				mov		edx,[esi]
				push	ebx
				mov		ebx,eax
				and		ebx,0xF0F0F0F0
				test	eax,eax
				jz		_nieje2
				and		al,0x0F
				jz		_byte2
				or		al,bl
				or		dl,dl
				jnz		_byte2
				mov		dl,al
_byte2:			and		ah,0x0F
				jz		_byte3
				or		ah,bh
				or		dh,dh
				jnz		_byte3
				mov		dh,ah
_byte3:			rol		eax,16
				rol		edx,16
				rol		ebx,16
				and		al,0x0F
				jz		_byte4
				or		al,bl
				or		dl,dl
				jnz		_byte4
				mov		dl,al
_byte4:			and		ah,0x0F
				jz		_byte5
				or		ah,bh
				or		dh,dh
				jnz		_byte5
				mov		dh,ah
_byte5:			rol		edx,16
				rol		eax,16
_nieje2:			mov		[ecx],edx
				mov		[edi],eax
				add		edi,4
				add		esi,4
				add		ecx,4
				pop		ebx
				dec		ebx
				jnz		_degraduj2
				pop		ebx
				pop		ecx
				pop		esi
				pop		edi
				ret
	}
}

int ClipLine(int) // because frame-pointer required
{
	asm {
	add esp,12
	pop ebp
				push	ebp
				mov		ebp,[ebp+32]
				mov		dword [clip_result],1
L54:			cmp		ebx,esi
				je		L68
				cmp		ecx,edi
				je		 L71
				xor		al,al
				cmp		ecx,[ebp+4]
				jge		L55
				or		al,01H
				jmp		L56
L55:			cmp		ecx,[ebp+12]
				jl		L56
				or		al,02H
L56:			cmp		ebx,[ebp+0]
				jge		L57
				or		al,04H
				jmp		L58
L57:			cmp		ebx,[ebp+8]
				jl		L58
				or		al,08H
L58:			xor		ah,ah
				cmp		edi,[ebp+4]
				jge		L59
				or		ah,01H
				jmp		L60
L59:			cmp		edi,[ebp+12]
				jl		L60
				or		ah,02H
L60:			cmp		esi,[ebp+0]
				jge		L61
				or		ah,04H
				jmp		L62
L61:			cmp		esi,[ebp+8]
				jl		L62
				or		ah,08H
L62:			mov		dl,al
				and		dl,ah
				jne		 L67
				mov		dl,al
				or		dl,ah
				je		 L74
				test	al,al
				jne		L63
				mov		al,ah
				xchg	esi,ebx
				xchg	edi,ecx

L63:			mov		[clip_result],eax
				test	al,01H
				je		L64
				mov		eax,[ebp+4]
				sub		eax,ecx
				push	ecx
				mov		ecx,eax
				mov		eax,esi
				sub		eax,ebx
				imul	ecx
				pop		ecx
				neg		ecx
				add		ecx,edi
				idiv	ecx
				add		ebx,eax
				mov		ecx,[ebp+4]
				jmp		L65
L64:			test	[clip_result],2
				je		L65
				mov		eax,esi
				sub		eax,ebx
				mov		edx,[ebp+12]
				dec		edx
				sub		edx,ecx
				imul	edx
				neg		ecx
				add		ecx,edi
				idiv	ecx
				add		ebx,eax
				mov		ecx,[ebp+12]
				dec		ecx
L65:			cmp		ebx,esi
				je		 L71
				test	[clip_result],4
				je		 L66
				mov		eax,[ebp+0]
				sub		eax,ebx
				push	ebx
				mov		ebx,eax
				mov		eax,edi
				sub		eax,ecx
				imul	ebx
				pop		ebx
				neg		ebx
				add		ebx,esi
				idiv	ebx
				add		ecx,eax
				mov		ebx,[ebp+0]
				jmp		L54
L66:			test	[clip_result], 8
				je		 L54
				mov		eax,edi
				sub		eax,ecx
				mov		edx,[ebp+8]
				dec		edx
				sub		edx,ebx
				imul	edx
				neg		ebx
				add		ebx,esi
				idiv	ebx
				add		ecx,eax
				mov		ebx,[ebp+8]
				dec		ebx
				jmp		L54
L67:			mov		eax,1
				jmp		L75
L68:			cmp		ecx,edi
				jle		L69
				xchg	edi,ecx
				xchg	esi,ebx
L69:			cmp		edi,[ebp+4]
				jl		L67
				cmp		ecx,[ebp+12]
				jge		L67
				cmp		ebx,[ebp+0]
				jl		L67
				cmp		ebx,[ebp+8]
				jae		L67
				cmp		edi,[ebp+12]
				jl		L70
				mov		edi,[ebp+12]
				dec		edi
L70:			cmp		ecx,[ebp+4]
				jge		L74
				mov		ecx,[ebp+4]
				jmp		L74
L71:			cmp		ebx,esi
				jle		L72
				xchg	esi,ebx
				xchg	edi,ecx
L72:			cmp		esi,[ebp+0]
				jl		L67
				cmp		ebx,[ebp+8]
				jge		L67
				cmp		ecx,[ebp+4]
				jl		L67
				cmp		ecx,[ebp+12]
				jae		L67
				cmp		esi,[ebp+8]
				jl		L73
				mov		esi,[ebp+8]
				dec		esi
L73:			cmp		ebx,[ebp+0]
				jge		L74
				mov		ebx,[ebp+0]
L74:			xor		eax,eax
L75:            pop		ebp
				ret
		}
}

int ClipLine2(int)  // because frame-pointer required
{
	asm {
	add esp,12
	pop ebp
				push	ebp
L76:			cmp		ebx,esi
				je		 L90
				cmp		ecx,edi
				je		 L93
				xor		al,al
				cmp		ecx,[clip_y_min]
				jge		L77
				or		al,1
				jmp		L78
L77:			cmp		ecx,[clip_y_max]
				jl		L78
				or		al,2
L78:			cmp		ebx,[clip_x_min]
				jge		L79
				or		al,4
				jmp		L80
L79:			cmp		ebx,[clip_x_max]
				jl		L80
				or		al,8
L80:			xor		ah,ah
				cmp		edi,[clip_y_min]
				jge		L81
				or		ah,1
				jmp		L82
L81:			cmp		edi,[clip_y_max]
				jl		L82
				or		ah,2
L82:			cmp		esi,[clip_x_min]
				jge		L83
				or		ah,4
				jmp		L84
L83:			cmp		esi,[clip_x_max]
				jl		L84
				or		ah,8
L84:			mov		dl,al
				and		dl,ah
				jne		 L89
				mov		dl,al
				or		dl,ah
				je		 L96
				test	al,al
				jne		L85
				mov		al,ah
				xchg	esi,ebx
				xchg	edi,ecx
L85:			mov		ebp,eax
				test	al,1
				je		L86
				mov		eax,[clip_y_min]
				sub		eax,ecx
				push	ecx
				mov		ecx,eax
				mov		eax,esi
				sub		eax,ebx
				imul	ecx
				pop		ecx
				neg		ecx
				add		ecx,edi
				idiv	ecx
				add		ebx,eax
				mov		ecx,[clip_y_min]
				jmp		L87
L86:			test	ebp,2
				je		L87
				mov		eax,esi
				sub		eax,ebx
				mov		edx,[clip_y_max]
				dec		edx
				sub		edx,ecx
				imul	edx
				neg		ecx
				add		ecx,edi
				idiv	ecx
				add		ebx,eax
				mov		ecx,[clip_y_max]
				dec		ecx
L87:			cmp		ebx,esi
				je		 L93
				test	ebp,4
				je		L88
				mov		eax,[clip_x_min]
				sub		eax,ebx
				push	ebx
				mov		ebx,eax
				mov		eax,edi
				sub		eax,ecx
				imul	ebx
				pop		ebx
				neg		ebx
				add		ebx,esi
				idiv	ebx
				add		ecx,eax
				mov		ebx,[clip_x_min]
				jmp		L76
L88:			test	ebp,8
				je		 L76
				mov		eax,edi
				sub		eax,ecx
				mov		edx,[clip_x_max]
				dec		edx
				sub		edx,ebx
				imul	edx
				neg		ebx
				add		ebx,esi
				idiv	ebx
				add		ecx,eax
				mov		ebx,[clip_x_max]
				dec		ebx
				jmp		L76
L89:			mov		eax,1
				jmp		 L97
L90:			cmp		ecx,edi
				jle		L91
				xchg	edi,ecx
				xchg	esi,ebx
L91:			cmp		edi,[clip_y_min]
				jl		L89
				cmp		ecx,[clip_y_max]
				jge		L89
				cmp		ebx,[clip_x_min]
				jl		L89
				cmp		ebx,[clip_x_max]
				jae		L89
				cmp		edi,[clip_y_max]
				jl		L92
				mov		edi,[clip_y_max]
				dec		edi
L92:			cmp		ecx,[clip_y_min]
				jge		L96
				mov		ecx,[clip_y_min]
				jmp		L96
L93:			cmp		ebx,esi
				jle		L94
				xchg	esi,ebx
				xchg	edi,ecx
L94:			cmp		esi,[clip_x_min]
				jl		L89
				cmp		ebx,[clip_x_max]
				jge		L89
				cmp		ecx,[clip_y_min]
				jl		L89
				cmp		ecx,[clip_y_max]
				jae		L89
				cmp		esi,[clip_x_max]
				jl		L95
				mov		esi,[clip_x_max]
				dec		esi
L95:			cmp		ebx,[clip_x_min]
				jge		L96
				mov		ebx,[clip_x_min]
L96:			xor		eax,eax
L97:			pop		ebp
				ret
	}
}


#define swap(a,b)           {a^=b; b^=a; a^=b;}
#define	MIN(a,b)	( (a) < (b) ? (a) : (b) )
#define MAX(a,b)	( (a) > (b) ? (a) : (b) )

//
//
static void _line(void (*draw) (int, int), int a1, int b1, int a2, int b2)
{
	int xend, yend, dx, dy, c1, c2, step;
	register int p, x, y;

	dx = abs(a2 - a1);
	dy = abs(b2 - b1);

	if (dx > 32000)
		return;					// bulgar const

	if (dy > 32000)
		return;

	if (dx > dy)
	{							/* slope < 1 => step in x direction */
		x = MIN(a1, a2);
		xend = MAX(a1, a2);
		if (x == a1)
		{
			y = b1;
			step = ((b2 - y) < 0 ? -1 : 1);
		}
		else
		{
			y = b2;
			step = ((b1 - y) < 0 ? -1 : 1);
		}

		p = 2 * dy - dx;
		c1 = 2 * dy;
		c2 = 2 * (dy - dx);

		draw(x, y);
		while (x < xend)
		{
			x++;
			if (p < 0)
			{
				p += c1;
			}
			else
			{
				y += step;
				p += c2;
			}
			draw(x, y);
		}
	}
	else
	{							/* slope > 1 => step in y direction */
		y = MIN(b1, b2);
		yend = MAX(b1, b2);
		if (y == b1)
		{
			x = a1;
			step = ((a2 - x) < 0 ? -1 : 1);
		}
		else
		{
			x = a2;
			step = ((a1 - x) < 0 ? -1 : 1);
		}

		p = 2 * dx - dy;
		c1 = 2 * dx;
		c2 = 2 * (dx - dy);

		draw(x, y);
		while (y < yend)
		{
			y++;
			if (p < 0)
			{
				p += c1;
			}
			else
			{
				x += step;
				p += c2;
			}
			draw(x, y);
		}
	}
}

void __draw_line(int x, int y, int w, int h, FGPixel ink, unsigned ppop)
{
	asm
	{
	add esp,12
	pop ebp
				push	ebp
				mov		ebp,esp
				push	edi
				push	esi
				push	ebx
				push	es

				movsx	esi,word[x]
				movsx	edi,word[y]
				movsx	ebx,word[w]
				movsx	ecx,word[h]
				call	ClipLine2
				test	eax,eax
				jne		L109

				mov		dword[x],esi
				mov		dword[y],edi
				mov		dword[w],ebx
				mov		dword[h],ecx
				push	h
				push	w
				push	y
				push	x
				push	offset __draw_point
				call	_line
				add 	esp,5*4

L109:			pop		es
				pop		ebx
				pop		esi
				pop		edi
				pop		ebp
				mov		eax,[clip_result]
				ret
	};
//	_line(__draw_point, x,y,x1,y1);
}

static int ww;
static FGPixel *pp;

static void Point(int x, int y)
{
	FGPixel *ptr = pp + ww * y + x;
	modify_point2(ptr);
}

int Line(int x, int y, int w, int h, int width, FGPixel *ptr, int *res)
{
	pp=ptr;
	ww=width;
	asm
	{
	add esp,12
	pop ebp
				push	ebp
				mov		ebp,esp
				push	edi
				push	esi
				push	ebx
				push	es

				movsx	esi,word[x]
				movsx	edi,word[y]
				movsx	ebx,word[w]
				movsx	ecx,word[h]
				call	ClipLine
				test	eax,eax
				jne		L109

				mov		dword[x],esi
				mov		dword[y],edi
				mov		dword[w],ebx
				mov		dword[h],ecx
				push	h
				push	w
				push	y
				push	x
				push	offset Point
				call	_line
				add 	esp,5*4

L109:			pop		es
				pop		ebx
				pop		esi
				pop		edi
				pop		ebp
				mov		eax,[clip_result]
				ret
	};
}

