/*
	An virtual parent for FGListBox that implement all stuff
*/

#ifndef __LISTBOX__
#define __LISTBOX__

#include "fglist.h"

//#pragma interface

class _listbox : public Slider
{
	protected:
		int		cursor; 			// visible cursor
		int		slider;			 	// for position of slider
		int		drop_down;			// size in visible lines
		int 	color_bg0, color_bg1, color_fg0, color_fg1; // colors
		int 	x, y,				// top left of widgets
				curr,				// current item or -1
				count,				// 0 ...
				fpol,				// first visible
				line,				// Y-position of line
				onew, oneh; 		// width x height of one item

		void	corecture(void);
		virtual void draw(void); // for slider
		virtual void DrawItem(int , int , int , int ) {}
		void 	Cursor(int);
		// try move cursor at new index and adjust all variables to new values
		int		AdjustCursor(int item);
		int		Enabled(void) { if (curr<0 || count<=0) return 0; return 1;}
		static  void	lbCall(Control *T);
	public:
		_listbox(int xs, int ys, int w, int h, int DropDown, Window *wind);
		void	SetColors(int a, int b, int c, int d)
		{
			color_bg0 = a; color_fg1 = c;
			color_bg1 = b; color_fg0 = d;
		}
		void 	Draw(int i=1);	// for listbox
		void 	ShowCursor(void);
		void 	HideCursor(void);
		void 	Up(void);
		void 	Down(void);
		void 	Begin(void);
		void 	End(void);
		void 	SetSize(int);
		int 	GetSize(void) const { return count; };
		void 	SetIndex(int);
		int 	GetIndex(void) const { return curr; };
		void 	SetIndexRel(int);
		int  	Test(int, int);
		int		DoListBox(int key);
		// compatibility
		int 	GetCurrent(void) const { return GetIndex(); };
		void 	SetToItemRel(int a) { SetIndexRel(a); }
		void 	Resize(int a) { SetSize(GetSize()+a); }
		void	SetToItem(int a) { SetIndex(a); }
		void	RedrawItem(void)
		{
			ShowCursor();
		}
};

/*
*/
template <class T> class FGListBoxTemplate : public _listbox
{
#ifndef __BORLANDC__
		typedef FGList<class id_string>::iterator Iter;
#endif
	protected:
		FGList<T>	items;
		int			update;

		virtual void DrawItem(int x, int y, int index, int flag) { }
		void (*show)(int flag, Window *wnd,int x,int y,void *ptr, int index);
	public:
		FGListBoxTemplate(int xs, int ys, int w, int h, int DropDown, Window *wind, void (*show_cb)(int , Window *,int,int,void *, int)=0)
		: _listbox(xs,ys,w,h,DropDown,wind)
		{
			update = 0;
			show = show_cb;
		}
		void DisableUpdate(void) { update = 0; }
		void Update(void)
		{
			update = 1;
			Draw(1);
		}
		void erase(int i)
		{
			items.erase(items.begin()+i);
			count--;
			if (update) Draw(0);
		}
		// set null state
		void clear(void)
		{
			count = fpol = line = curr = 0;
			Draw(0);
			update = 0;
			items.clear();
		}
		char *item(int i)
		{
			Iter ti = items.begin();
			return ti[i].str;
		}
		void insert(T s)
		{
			items.push_back(s);
			count++;
			if (update) Draw(0);
		}
		void insert(int i, T s)
		{
			items.insert(items.begin()+i,s);
			count++;
			if (update) Draw(0);
		}
		void change(int i, T s)
		{
			Iter ti = items.begin();
			ti[i] = T(s);
		}
};

struct id_string
{
	char str[32];
	id_string()
	{
		*str=0;
	}
	id_string(char *s)
	{
		strncpy(str,s,31);
		str[31]=0;
	}
};

/*
*/

class FGListBox : public FGListBoxTemplate<struct id_string>
{
		typedef FGList<id_string>::iterator Iter;
	public:
		FGListBox(int xs, int ys, int w, int h, int DropDown, Window *wind, void (*show_cb)(int , Window *,int,int,void *, int)=0)
		: FGListBoxTemplate<id_string>(xs, ys, w, h, DropDown, wind, show_cb)
		{
		}
		void DrawItem(int x, int y, int index, int flag)
		{
			if (index>=count) return; // out of range
			Iter i=items.begin();
			set_colors(flag?color_fg1:color_fg0,flag?color_bg1:color_bg0);
			if (show==0) owner->printf(x+4,y,i[index].str);
			else show(flag, owner,x,y,i[index].str,index);
		}
};


#endif

