/*
    OpenGUI - Drawing & Windowing library

    Copyright (C) 1996,2002  Marian Krivos

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    nezmar@atlas.sk
    QNX 4.x support

*/
#include "config.h"
#include "fastgl.h"
#include "_fastgl.h"

#include <sys/mouse.h>
#include <sys/dev.h>
#include <sys/proxy.h>
#include <sys/kernel.h>

#include "drivers.h"
#include "qnx.h"

int FGQNXDriver::set_mode(int ww, int hh)
{
   	req_w = ww;
    req_h = hh;
	
	FGDriver::set_mode(w,h);
   	mode_num = find(req_w, req_h);
    if (mode_num==-1)
	{
       	printf("Mode %dx%d not found!\n", ww, hh);
        return 0;
    }
	if (verbose) printf("\tmode \"%dx%dx%d\" as VESA:0x%x passed ... ", modelist[mode_num].w, modelist[mode_num].h, bpp*8, modelist[mode_num].mode);
	videobase = 0;	// always NULL as segment start
	islinear = 0;
	int value = modelist[mode_num].mode;
	if (_setvideomode(value) ==	0) return 0; //set properly mode
	if (verbose) printf("O.K.\n");
	virt_w = req_w;
	virt_h = req_h;
	subname = strdup(drv_name[driver]);
	synch = 0;
	return postinit();
}

int FGQNXDriver::get_event(int& type, int& key, int& x, int& y, int& buttons)
{
	GuiEvent e;
	if (Creceive(user_pid,&e,sizeof(GuiEvent)) !=	-1)
	{
		x = e.GetX();
		y = e.GetY();
		type = e.GetType();
		buttons = e.GetButtons();
		key = e.GetKey();
		Reply(user_pid,&e,sizeof(GuiEvent));
		return TRUE;
	}
	return FALSE;
}
