/*
    OpenGUI - Drawing & Windowing library

    Copyright (C) 1996,2002  Marian Krivos

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    nezmar@atlas.sk

*/

#include "Ph.h"
#include "Pt.h"
#include <photon/Pg.h>
#include <photon/PdDirect.h>

class FGPhotonDriver : public FGDriver
{
		int		oldx, oldy, but;
		int		mousex, mousey, xmax, ymax;
	protected:
	public:
		virtual int	available(void)
		{
			int phstat=-1;

			phstat=PtInit(0);
			if (phstat==0)
			{
				return 0;
			}
			return 1;
		}
		FGPhotonDriver(void) : FGDriver("Photon")
        	{
        	}
		~FGPhotonDriver()
		{
		}
		virtual int text_mode(void)
		{
			return TRUE;
		}
		virtual int	link(void)
		{
   	     	return 1;
        }
		virtual void get_all_modes(vmode *p)
		{
			total_modes = 0;
		}
		virtual int set_mode(int ww, int hh);
		virtual int set_mouse(void)
		{
			mouse_string = "QNX_INPUT_SERVER";
			return ismouse = 1;
		}
		virtual void reset_mouse(void)
		{
			mouseflag = -1;
			ismouse = 0;
		}
		virtual int set_keyboard(void)
		{
			iskeyboard	= 1;
			return TRUE;
		}
		virtual void reset_keyboard(void)
		{
			iskeyboard = 0;
		}
		virtual int get_event(int& type, int& key, int& x, int& y, int& buttons);
};
