#include "config.h"
#include "fastgl.h"
#include "_fastgl.h"
#include "drivers.h"
#include "win32.h"

//#define WMMSG_DEBUG

HWND        FGWin32Driver::wnd;
HINSTANCE	FGWin32Driver::hInstance;		// Instance handle

LPDIRECTDRAWSURFACE FGWin32Driver::primary;
LPDIRECTDRAWSURFACE FGWin32Driver::secondary;
LPDIRECTDRAWSURFACE FGWin32Driver::current;
LPDIRECTDRAWPALETTE FGWin32Driver::palette;

#ifdef WMMSG_DEBUG
#define MAX_WMMSG	(sizeof(wmtab)/sizeof(wmtab[0]))

#define INPUT_QSIZE	32		/* Buffer up to 32 input messages */

char *wmtab[] = {
	"WM_NULL",
	"WM_CREATE",
	"WM_DESTROY",
	"WM_MOVE",
	"UNKNOWN (4)",
	"WM_SIZE",
	"WM_ACTIVATE",
	"WM_SETFOCUS",
	"WM_KILLFOCUS",
	"UNKNOWN (9)",
	"WM_ENABLE",
	"WM_SETREDRAW",
	"WM_SETTEXT",
	"WM_GETTEXT",
	"WM_GETTEXTLENGTH",
	"WM_PAINT",
	"WM_CLOSE",
	"WM_QUERYENDSESSION",
	"WM_QUIT",
	"WM_QUERYOPEN",
	"WM_ERASEBKGND",
	"WM_SYSCOLORCHANGE",
	"WM_ENDSESSION",
	"UNKNOWN (23)",
	"WM_SHOWWINDOW",
	"UNKNOWN (25)",
	"WM_SETTINGCHANGE",
	"WM_DEVMODECHANGE",
	"WM_ACTIVATEAPP",
	"WM_FONTCHANGE",
	"WM_TIMECHANGE",
	"WM_CANCELMODE",
	"WM_SETCURSOR",
	"WM_MOUSEACTIVATE",
	"WM_CHILDACTIVATE",
	"WM_QUEUESYNC",
	"WM_GETMINMAXINFO",
	"UNKNOWN (37)",
	"WM_PAINTICON",
	"WM_ICONERASEBKGND",
	"WM_NEXTDLGCTL",
	"UNKNOWN (41)",
	"WM_SPOOLERSTATUS",
	"WM_DRAWITEM",
	"WM_MEASUREITEM",
	"WM_DELETEITEM",
	"WM_VKEYTOITEM",
	"WM_CHARTOITEM",
	"WM_SETFONT",
	"WM_GETFONT",
	"WM_SETHOTKEY",
	"WM_GETHOTKEY",
	"UNKNOWN (52)",
	"UNKNOWN (53)",
	"UNKNOWN (54)",
	"WM_QUERYDRAGICON",
	"UNKNOWN (56)",
	"WM_COMPAREITEM",
	"UNKNOWN (58)",
	"UNKNOWN (59)",
	"UNKNOWN (60)",
	"WM_GETOBJECT",
	"UNKNOWN (62)",
	"UNKNOWN (63)",
	"UNKNOWN (64)",
	"WM_COMPACTING",
	"UNKNOWN (66)",
	"UNKNOWN (67)",
	"WM_COMMNOTIFY",
	"UNKNOWN (69)",
	"WM_WINDOWPOSCHANGING",
	"WM_WINDOWPOSCHANGED",
	"WM_POWER",
	"UNKNOWN (73)",
	"WM_COPYDATA",
	"WM_CANCELJOURNAL",
	"UNKNOWN (76)",
	"UNKNOWN (77)",
	"WM_NOTIFY",
	"UNKNOWN (79)",
	"WM_INPUTLANGCHANGEREQUEST",
	"WM_INPUTLANGCHANGE",
	"WM_TCARD",
	"WM_HELP",
	"WM_USERCHANGED",
	"WM_NOTIFYFORMAT",
	"UNKNOWN (86)",
	"UNKNOWN (87)",
	"UNKNOWN (88)",
	"UNKNOWN (89)",
	"UNKNOWN (90)",
	"UNKNOWN (91)",
	"UNKNOWN (92)",
	"UNKNOWN (93)",
	"UNKNOWN (94)",
	"UNKNOWN (95)",
	"UNKNOWN (96)",
	"UNKNOWN (97)",
	"UNKNOWN (98)",
	"UNKNOWN (99)",
	"UNKNOWN (100)",
	"UNKNOWN (101)",
	"UNKNOWN (102)",
	"UNKNOWN (103)",
	"UNKNOWN (104)",
	"UNKNOWN (105)",
	"UNKNOWN (106)",
	"UNKNOWN (107)",
	"UNKNOWN (108)",
	"UNKNOWN (109)",
	"UNKNOWN (110)",
	"UNKNOWN (111)",
	"UNKNOWN (112)",
	"UNKNOWN (113)",
	"UNKNOWN (114)",
	"UNKNOWN (115)",
	"UNKNOWN (116)",
	"UNKNOWN (117)",
	"UNKNOWN (118)",
	"UNKNOWN (119)",
	"UNKNOWN (120)",
	"UNKNOWN (121)",
	"UNKNOWN (122)",
	"WM_CONTEXTMENU",
	"WM_STYLECHANGING",
	"WM_STYLECHANGED",
	"WM_DISPLAYCHANGE",
	"WM_GETICON",
	"WM_SETICON",
	"WM_NCCREATE",
	"WM_NCDESTROY",
	"WM_NCCALCSIZE",
	"WM_NCHITTEST",
	"WM_NCPAINT",
	"WM_NCACTIVATE",
	"WM_GETDLGCODE",
	"WM_SYNCPAINT",
	"UNKNOWN (137)",
	"UNKNOWN (138)",
	"UNKNOWN (139)",
	"UNKNOWN (140)",
	"UNKNOWN (141)",
	"UNKNOWN (142)",
	"UNKNOWN (143)",
	"UNKNOWN (144)",
	"UNKNOWN (145)",
	"UNKNOWN (146)",
	"UNKNOWN (147)",
	"UNKNOWN (148)",
	"UNKNOWN (149)",
	"UNKNOWN (150)",
	"UNKNOWN (151)",
	"UNKNOWN (152)",
	"UNKNOWN (153)",
	"UNKNOWN (154)",
	"UNKNOWN (155)",
	"UNKNOWN (156)",
	"UNKNOWN (157)",
	"UNKNOWN (158)",
	"UNKNOWN (159)",
	"WM_NCMOUSEMOVE",
	"WM_NCLBUTTONDOWN",
	"WM_NCLBUTTONUP",
	"WM_NCLBUTTONDBLCLK",
	"WM_NCRBUTTONDOWN",
	"WM_NCRBUTTONUP",
	"WM_NCRBUTTONDBLCLK",
	"WM_NCMBUTTONDOWN",
	"WM_NCMBUTTONUP",
	"WM_NCMBUTTONDBLCLK",
	"UNKNOWN (170)",
	"UNKNOWN (171)",
	"UNKNOWN (172)",
	"UNKNOWN (173)",
	"UNKNOWN (174)",
	"UNKNOWN (175)",
	"UNKNOWN (176)",
	"UNKNOWN (177)",
	"UNKNOWN (178)",
	"UNKNOWN (179)",
	"UNKNOWN (180)",
	"UNKNOWN (181)",
	"UNKNOWN (182)",
	"UNKNOWN (183)",
	"UNKNOWN (184)",
	"UNKNOWN (185)",
	"UNKNOWN (186)",
	"UNKNOWN (187)",
	"UNKNOWN (188)",
	"UNKNOWN (189)",
	"UNKNOWN (190)",
	"UNKNOWN (191)",
	"UNKNOWN (192)",
	"UNKNOWN (193)",
	"UNKNOWN (194)",
	"UNKNOWN (195)",
	"UNKNOWN (196)",
	"UNKNOWN (197)",
	"UNKNOWN (198)",
	"UNKNOWN (199)",
	"UNKNOWN (200)",
	"UNKNOWN (201)",
	"UNKNOWN (202)",
	"UNKNOWN (203)",
	"UNKNOWN (204)",
	"UNKNOWN (205)",
	"UNKNOWN (206)",
	"UNKNOWN (207)",
	"UNKNOWN (208)",
	"UNKNOWN (209)",
	"UNKNOWN (210)",
	"UNKNOWN (211)",
	"UNKNOWN (212)",
	"UNKNOWN (213)",
	"UNKNOWN (214)",
	"UNKNOWN (215)",
	"UNKNOWN (216)",
	"UNKNOWN (217)",
	"UNKNOWN (218)",
	"UNKNOWN (219)",
	"UNKNOWN (220)",
	"UNKNOWN (221)",
	"UNKNOWN (222)",
	"UNKNOWN (223)",
	"UNKNOWN (224)",
	"UNKNOWN (225)",
	"UNKNOWN (226)",
	"UNKNOWN (227)",
	"UNKNOWN (228)",
	"UNKNOWN (229)",
	"UNKNOWN (230)",
	"UNKNOWN (231)",
	"UNKNOWN (232)",
	"UNKNOWN (233)",
	"UNKNOWN (234)",
	"UNKNOWN (235)",
	"UNKNOWN (236)",
	"UNKNOWN (237)",
	"UNKNOWN (238)",
	"UNKNOWN (239)",
	"UNKNOWN (240)",
	"UNKNOWN (241)",
	"UNKNOWN (242)",
	"UNKNOWN (243)",
	"UNKNOWN (244)",
	"UNKNOWN (245)",
	"UNKNOWN (246)",
	"UNKNOWN (247)",
	"UNKNOWN (248)",
	"UNKNOWN (249)",
	"UNKNOWN (250)",
	"UNKNOWN (251)",
	"UNKNOWN (252)",
	"UNKNOWN (253)",
	"UNKNOWN (254)",
	"UNKNOWN (255)",
	"WM_KEYDOWN",
	"WM_KEYUP",
	"WM_CHAR",
	"WM_DEADCHAR",
	"WM_SYSKEYDOWN",
	"WM_SYSKEYUP",
	"WM_SYSCHAR",
	"WM_SYSDEADCHAR",
	"WM_KEYLAST",
	"UNKNOWN (265)",
	"UNKNOWN (266)",
	"UNKNOWN (267)",
	"UNKNOWN (268)",
	"UNKNOWN (269)",
	"UNKNOWN (270)",
	"UNKNOWN (271)",
	"WM_INITDIALOG",
	"WM_COMMAND",
	"WM_SYSCOMMAND",
	"WM_TIMER",
	"WM_HSCROLL",
	"WM_VSCROLL",
	"WM_INITMENU",
	"WM_INITMENUPOPUP",
	"UNKNOWN (280)",
	"UNKNOWN (281)",
	"UNKNOWN (282)",
	"UNKNOWN (283)",
	"UNKNOWN (284)",
	"UNKNOWN (285)",
	"UNKNOWN (286)",
	"WM_MENUSELECT",
	"WM_MENUCHAR",
	"WM_ENTERIDLE",
	"WM_MENURBUTTONUP",
	"WM_MENUDRAG",
	"WM_MENUGETOBJECT",
	"WM_UNINITMENUPOPUP",
	"WM_MENUCOMMAND",
	"UNKNOWN (295)",
	"UNKNOWN (296)",
	"UNKNOWN (297)",
	"UNKNOWN (298)",
	"UNKNOWN (299)",
	"UNKNOWN (300)",
	"UNKNOWN (301)",
	"UNKNOWN (302)",
	"UNKNOWN (303)",
	"UNKNOWN (304)",
	"UNKNOWN (305)",
	"WM_CTLCOLORMSGBOX",
	"WM_CTLCOLOREDIT",
	"WM_CTLCOLORLISTBOX",
	"WM_CTLCOLORBTN",
	"WM_CTLCOLORDLG",
	"WM_CTLCOLORSCROLLBAR",
	"WM_CTLCOLORSTATIC",
	"UNKNOWN (313)",
	"UNKNOWN (314)",
	"UNKNOWN (315)",
	"UNKNOWN (316)",
	"UNKNOWN (317)",
	"UNKNOWN (318)",
	"UNKNOWN (319)",
	"UNKNOWN (320)",
	"UNKNOWN (321)",
	"UNKNOWN (322)",
	"UNKNOWN (323)",
	"UNKNOWN (324)",
	"UNKNOWN (325)",
	"UNKNOWN (326)",
	"UNKNOWN (327)",
	"UNKNOWN (328)",
	"UNKNOWN (329)",
	"UNKNOWN (330)",
	"UNKNOWN (331)",
	"UNKNOWN (332)",
	"UNKNOWN (333)",
	"UNKNOWN (334)",
	"UNKNOWN (335)",
	"UNKNOWN (336)",
	"UNKNOWN (337)",
	"UNKNOWN (338)",
	"UNKNOWN (339)",
	"UNKNOWN (340)",
	"UNKNOWN (341)",
	"UNKNOWN (342)",
	"UNKNOWN (343)",
	"UNKNOWN (344)",
	"UNKNOWN (345)",
	"UNKNOWN (346)",
	"UNKNOWN (347)",
	"UNKNOWN (348)",
	"UNKNOWN (349)",
	"UNKNOWN (350)",
	"UNKNOWN (351)",
	"UNKNOWN (352)",
	"UNKNOWN (353)",
	"UNKNOWN (354)",
	"UNKNOWN (355)",
	"UNKNOWN (356)",
	"UNKNOWN (357)",
	"UNKNOWN (358)",
	"UNKNOWN (359)",
	"UNKNOWN (360)",
	"UNKNOWN (361)",
	"UNKNOWN (362)",
	"UNKNOWN (363)",
	"UNKNOWN (364)",
	"UNKNOWN (365)",
	"UNKNOWN (366)",
	"UNKNOWN (367)",
	"UNKNOWN (368)",
	"UNKNOWN (369)",
	"UNKNOWN (370)",
	"UNKNOWN (371)",
	"UNKNOWN (372)",
	"UNKNOWN (373)",
	"UNKNOWN (374)",
	"UNKNOWN (375)",
	"UNKNOWN (376)",
	"UNKNOWN (377)",
	"UNKNOWN (378)",
	"UNKNOWN (379)",
	"UNKNOWN (380)",
	"UNKNOWN (381)",
	"UNKNOWN (382)",
	"UNKNOWN (383)",
	"UNKNOWN (384)",
	"UNKNOWN (385)",
	"UNKNOWN (386)",
	"UNKNOWN (387)",
	"UNKNOWN (388)",
	"UNKNOWN (389)",
	"UNKNOWN (390)",
	"UNKNOWN (391)",
	"UNKNOWN (392)",
	"UNKNOWN (393)",
	"UNKNOWN (394)",
	"UNKNOWN (395)",
	"UNKNOWN (396)",
	"UNKNOWN (397)",
	"UNKNOWN (398)",
	"UNKNOWN (399)",
	"UNKNOWN (400)",
	"UNKNOWN (401)",
	"UNKNOWN (402)",
	"UNKNOWN (403)",
	"UNKNOWN (404)",
	"UNKNOWN (405)",
	"UNKNOWN (406)",
	"UNKNOWN (407)",
	"UNKNOWN (408)",
	"UNKNOWN (409)",
	"UNKNOWN (410)",
	"UNKNOWN (411)",
	"UNKNOWN (412)",
	"UNKNOWN (413)",
	"UNKNOWN (414)",
	"UNKNOWN (415)",
	"UNKNOWN (416)",
	"UNKNOWN (417)",
	"UNKNOWN (418)",
	"UNKNOWN (419)",
	"UNKNOWN (420)",
	"UNKNOWN (421)",
	"UNKNOWN (422)",
	"UNKNOWN (423)",
	"UNKNOWN (424)",
	"UNKNOWN (425)",
	"UNKNOWN (426)",
	"UNKNOWN (427)",
	"UNKNOWN (428)",
	"UNKNOWN (429)",
	"UNKNOWN (430)",
	"UNKNOWN (431)",
	"UNKNOWN (432)",
	"UNKNOWN (433)",
	"UNKNOWN (434)",
	"UNKNOWN (435)",
	"UNKNOWN (436)",
	"UNKNOWN (437)",
	"UNKNOWN (438)",
	"UNKNOWN (439)",
	"UNKNOWN (440)",
	"UNKNOWN (441)",
	"UNKNOWN (442)",
	"UNKNOWN (443)",
	"UNKNOWN (444)",
	"UNKNOWN (445)",
	"UNKNOWN (446)",
	"UNKNOWN (447)",
	"UNKNOWN (448)",
	"UNKNOWN (449)",
	"UNKNOWN (450)",
	"UNKNOWN (451)",
	"UNKNOWN (452)",
	"UNKNOWN (453)",
	"UNKNOWN (454)",
	"UNKNOWN (455)",
	"UNKNOWN (456)",
	"UNKNOWN (457)",
	"UNKNOWN (458)",
	"UNKNOWN (459)",
	"UNKNOWN (460)",
	"UNKNOWN (461)",
	"UNKNOWN (462)",
	"UNKNOWN (463)",
	"UNKNOWN (464)",
	"UNKNOWN (465)",
	"UNKNOWN (466)",
	"UNKNOWN (467)",
	"UNKNOWN (468)",
	"UNKNOWN (469)",
	"UNKNOWN (470)",
	"UNKNOWN (471)",
	"UNKNOWN (472)",
	"UNKNOWN (473)",
	"UNKNOWN (474)",
	"UNKNOWN (475)",
	"UNKNOWN (476)",
	"UNKNOWN (477)",
	"UNKNOWN (478)",
	"UNKNOWN (479)",
	"UNKNOWN (480)",
	"UNKNOWN (481)",
	"UNKNOWN (482)",
	"UNKNOWN (483)",
	"UNKNOWN (484)",
	"UNKNOWN (485)",
	"UNKNOWN (486)",
	"UNKNOWN (487)",
	"UNKNOWN (488)",
	"UNKNOWN (489)",
	"UNKNOWN (490)",
	"UNKNOWN (491)",
	"UNKNOWN (492)",
	"UNKNOWN (493)",
	"UNKNOWN (494)",
	"UNKNOWN (495)",
	"UNKNOWN (496)",
	"UNKNOWN (497)",
	"UNKNOWN (498)",
	"UNKNOWN (499)",
	"UNKNOWN (500)",
	"UNKNOWN (501)",
	"UNKNOWN (502)",
	"UNKNOWN (503)",
	"UNKNOWN (504)",
	"UNKNOWN (505)",
	"UNKNOWN (506)",
	"UNKNOWN (507)",
	"UNKNOWN (508)",
	"UNKNOWN (509)",
	"UNKNOWN (510)",
	"UNKNOWN (511)",
	"WM_MOUSEMOVE",
	"WM_LBUTTONDOWN",
	"WM_LBUTTONUP",
	"WM_LBUTTONDBLCLK",
	"WM_RBUTTONDOWN",
	"WM_RBUTTONUP",
	"WM_RBUTTONDBLCLK",
	"WM_MBUTTONDOWN",
	"WM_MBUTTONUP",
	"WM_MOUSELAST",
	"WM_MOUSELAST",
	"UNKNOWN (523)",
	"UNKNOWN (524)",
	"UNKNOWN (525)",
	"UNKNOWN (526)",
	"UNKNOWN (527)",
	"WM_PARENTNOTIFY",
	"WM_ENTERMENULOOP",
	"WM_EXITMENULOOP",
	"WM_NEXTMENU",
	"WM_SIZING",
	"WM_CAPTURECHANGED",
	"WM_MOVING",
	"UNKNOWN (535)",
	"WM_POWERBROADCAST",
	"WM_DEVICECHANGE",
	"UNKNOWN (538)",
	"UNKNOWN (539)",
	"UNKNOWN (540)",
	"UNKNOWN (541)",
	"UNKNOWN (542)",
	"UNKNOWN (543)",
	"WM_MDICREATE",
	"WM_MDIDESTROY",
	"WM_MDIACTIVATE",
	"WM_MDIRESTORE",
	"WM_MDINEXT",
	"WM_MDIMAXIMIZE",
	"WM_MDITILE",
	"WM_MDICASCADE",
	"WM_MDIICONARRANGE",
	"WM_MDIGETACTIVE",
	"UNKNOWN (554)",
	"UNKNOWN (555)",
	"UNKNOWN (556)",
	"UNKNOWN (557)",
	"UNKNOWN (558)",
	"UNKNOWN (559)",
	"WM_MDISETMENU",
	"WM_ENTERSIZEMOVE",
	"WM_EXITSIZEMOVE",
	"WM_DROPFILES",
	"WM_MDIREFRESHMENU",
	"UNKNOWN (565)",
	"UNKNOWN (566)",
	"UNKNOWN (567)",
	"UNKNOWN (568)",
	"UNKNOWN (569)",
	"UNKNOWN (570)",
	"UNKNOWN (571)",
	"UNKNOWN (572)",
	"UNKNOWN (573)",
	"UNKNOWN (574)",
	"UNKNOWN (575)",
	"UNKNOWN (576)",
	"UNKNOWN (577)",
	"UNKNOWN (578)",
	"UNKNOWN (579)",
	"UNKNOWN (580)",
	"UNKNOWN (581)",
	"UNKNOWN (582)",
	"UNKNOWN (583)",
	"UNKNOWN (584)",
	"UNKNOWN (585)",
	"UNKNOWN (586)",
	"UNKNOWN (587)",
	"UNKNOWN (588)",
	"UNKNOWN (589)",
	"UNKNOWN (590)",
	"UNKNOWN (591)",
	"UNKNOWN (592)",
	"UNKNOWN (593)",
	"UNKNOWN (594)",
	"UNKNOWN (595)",
	"UNKNOWN (596)",
	"UNKNOWN (597)",
	"UNKNOWN (598)",
	"UNKNOWN (599)",
	"UNKNOWN (600)",
	"UNKNOWN (601)",
	"UNKNOWN (602)",
	"UNKNOWN (603)",
	"UNKNOWN (604)",
	"UNKNOWN (605)",
	"UNKNOWN (606)",
	"UNKNOWN (607)",
	"UNKNOWN (608)",
	"UNKNOWN (609)",
	"UNKNOWN (610)",
	"UNKNOWN (611)",
	"UNKNOWN (612)",
	"UNKNOWN (613)",
	"UNKNOWN (614)",
	"UNKNOWN (615)",
	"UNKNOWN (616)",
	"UNKNOWN (617)",
	"UNKNOWN (618)",
	"UNKNOWN (619)",
	"UNKNOWN (620)",
	"UNKNOWN (621)",
	"UNKNOWN (622)",
	"UNKNOWN (623)",
	"UNKNOWN (624)",
	"UNKNOWN (625)",
	"UNKNOWN (626)",
	"UNKNOWN (627)",
	"UNKNOWN (628)",
	"UNKNOWN (629)",
	"UNKNOWN (630)",
	"UNKNOWN (631)",
	"UNKNOWN (632)",
	"UNKNOWN (633)",
	"UNKNOWN (634)",
	"UNKNOWN (635)",
	"UNKNOWN (636)",
	"UNKNOWN (637)",
	"UNKNOWN (638)",
	"UNKNOWN (639)",
	"UNKNOWN (640)",
	"UNKNOWN (641)",
	"UNKNOWN (642)",
	"UNKNOWN (643)",
	"UNKNOWN (644)",
	"UNKNOWN (645)",
	"UNKNOWN (646)",
	"UNKNOWN (647)",
	"UNKNOWN (648)",
	"UNKNOWN (649)",
	"UNKNOWN (650)",
	"UNKNOWN (651)",
	"UNKNOWN (652)",
	"UNKNOWN (653)",
	"UNKNOWN (654)",
	"UNKNOWN (655)",
	"UNKNOWN (656)",
	"UNKNOWN (657)",
	"UNKNOWN (658)",
	"UNKNOWN (659)",
	"UNKNOWN (660)",
	"UNKNOWN (661)",
	"UNKNOWN (662)",
	"UNKNOWN (663)",
	"UNKNOWN (664)",
	"UNKNOWN (665)",
	"UNKNOWN (666)",
	"UNKNOWN (667)",
	"UNKNOWN (668)",
	"UNKNOWN (669)",
	"UNKNOWN (670)",
	"UNKNOWN (671)",
	"UNKNOWN (672)",
	"WM_MOUSEHOVER",
	"UNKNOWN (674)",
	"WM_MOUSELEAVE",
	"UNKNOWN (676)",
	"UNKNOWN (677)",
	"UNKNOWN (678)",
	"UNKNOWN (679)",
	"UNKNOWN (680)",
	"UNKNOWN (681)",
	"UNKNOWN (682)",
	"UNKNOWN (683)",
	"UNKNOWN (684)",
	"UNKNOWN (685)",
	"UNKNOWN (686)",
	"UNKNOWN (687)",
	"UNKNOWN (688)",
	"UNKNOWN (689)",
	"UNKNOWN (690)",
	"UNKNOWN (691)",
	"UNKNOWN (692)",
	"UNKNOWN (693)",
	"UNKNOWN (694)",
	"UNKNOWN (695)",
	"UNKNOWN (696)",
	"UNKNOWN (697)",
	"UNKNOWN (698)",
	"UNKNOWN (699)",
	"UNKNOWN (700)",
	"UNKNOWN (701)",
	"UNKNOWN (702)",
	"UNKNOWN (703)",
	"UNKNOWN (704)",
	"UNKNOWN (705)",
	"UNKNOWN (706)",
	"UNKNOWN (707)",
	"UNKNOWN (708)",
	"UNKNOWN (709)",
	"UNKNOWN (710)",
	"UNKNOWN (711)",
	"UNKNOWN (712)",
	"UNKNOWN (713)",
	"UNKNOWN (714)",
	"UNKNOWN (715)",
	"UNKNOWN (716)",
	"UNKNOWN (717)",
	"UNKNOWN (718)",
	"UNKNOWN (719)",
	"UNKNOWN (720)",
	"UNKNOWN (721)",
	"UNKNOWN (722)",
	"UNKNOWN (723)",
	"UNKNOWN (724)",
	"UNKNOWN (725)",
	"UNKNOWN (726)",
	"UNKNOWN (727)",
	"UNKNOWN (728)",
	"UNKNOWN (729)",
	"UNKNOWN (730)",
	"UNKNOWN (731)",
	"UNKNOWN (732)",
	"UNKNOWN (733)",
	"UNKNOWN (734)",
	"UNKNOWN (735)",
	"UNKNOWN (736)",
	"UNKNOWN (737)",
	"UNKNOWN (738)",
	"UNKNOWN (739)",
	"UNKNOWN (740)",
	"UNKNOWN (741)",
	"UNKNOWN (742)",
	"UNKNOWN (743)",
	"UNKNOWN (744)",
	"UNKNOWN (745)",
	"UNKNOWN (746)",
	"UNKNOWN (747)",
	"UNKNOWN (748)",
	"UNKNOWN (749)",
	"UNKNOWN (750)",
	"UNKNOWN (751)",
	"UNKNOWN (752)",
	"UNKNOWN (753)",
	"UNKNOWN (754)",
	"UNKNOWN (755)",
	"UNKNOWN (756)",
	"UNKNOWN (757)",
	"UNKNOWN (758)",
	"UNKNOWN (759)",
	"UNKNOWN (760)",
	"UNKNOWN (761)",
	"UNKNOWN (762)",
	"UNKNOWN (763)",
	"UNKNOWN (764)",
	"UNKNOWN (765)",
	"UNKNOWN (766)",
	"UNKNOWN (767)",
	"WM_CUT",
	"WM_COPY",
	"WM_PASTE",
	"WM_CLEAR",
	"WM_UNDO",
	"WM_RENDERFORMAT",
	"WM_RENDERALLFORMATS",
	"WM_DESTROYCLIPBOARD",
	"WM_DRAWCLIPBOARD",
	"WM_PAINTCLIPBOARD",
	"WM_VSCROLLCLIPBOARD",
	"WM_SIZECLIPBOARD",
	"WM_ASKCBFORMATNAME",
	"WM_CHANGECBCHAIN",
	"WM_HSCROLLCLIPBOARD",
	"WM_QUERYNEWPALETTE",
	"WM_PALETTEISCHANGING",
	"WM_PALETTECHANGED",
	"WM_HOTKEY",
	"UNKNOWN (787)",
	"UNKNOWN (788)",
	"UNKNOWN (789)",
	"UNKNOWN (790)",
	"WM_PRINT",
	"WM_PRINTCLIENT",
	"UNKNOWN (793)",
	"UNKNOWN (794)",
	"UNKNOWN (795)",
	"UNKNOWN (796)",
	"UNKNOWN (797)",
	"UNKNOWN (798)",
	"UNKNOWN (799)",
	"UNKNOWN (800)",
	"UNKNOWN (801)",
	"UNKNOWN (802)",
	"UNKNOWN (803)",
	"UNKNOWN (804)",
	"UNKNOWN (805)",
	"UNKNOWN (806)",
	"UNKNOWN (807)",
	"UNKNOWN (808)",
	"UNKNOWN (809)",
	"UNKNOWN (810)",
	"UNKNOWN (811)",
	"UNKNOWN (812)",
	"UNKNOWN (813)",
	"UNKNOWN (814)",
	"UNKNOWN (815)",
	"UNKNOWN (816)",
	"UNKNOWN (817)",
	"UNKNOWN (818)",
	"UNKNOWN (819)",
	"UNKNOWN (820)",
	"UNKNOWN (821)",
	"UNKNOWN (822)",
	"UNKNOWN (823)",
	"UNKNOWN (824)",
	"UNKNOWN (825)",
	"UNKNOWN (826)",
	"UNKNOWN (827)",
	"UNKNOWN (828)",
	"UNKNOWN (829)",
	"UNKNOWN (830)",
	"UNKNOWN (831)",
	"UNKNOWN (832)",
	"UNKNOWN (833)",
	"UNKNOWN (834)",
	"UNKNOWN (835)",
	"UNKNOWN (836)",
	"UNKNOWN (837)",
	"UNKNOWN (838)",
	"UNKNOWN (839)",
	"UNKNOWN (840)",
	"UNKNOWN (841)",
	"UNKNOWN (842)",
	"UNKNOWN (843)",
	"UNKNOWN (844)",
	"UNKNOWN (845)",
	"UNKNOWN (846)",
	"UNKNOWN (847)",
	"UNKNOWN (848)",
	"UNKNOWN (849)",
	"UNKNOWN (850)",
	"UNKNOWN (851)",
	"UNKNOWN (852)",
	"UNKNOWN (853)",
	"UNKNOWN (854)",
	"UNKNOWN (855)",
	"WM_HANDHELDFIRST",
	"UNKNOWN (857)",
	"UNKNOWN (858)",
	"UNKNOWN (859)",
	"UNKNOWN (860)",
	"UNKNOWN (861)",
	"UNKNOWN (862)",
	"WM_HANDHELDLAST",
	"WM_AFXFIRST",
	"UNKNOWN (865)",
	"UNKNOWN (866)",
	"UNKNOWN (867)",
	"UNKNOWN (868)",
	"UNKNOWN (869)",
	"UNKNOWN (870)",
	"UNKNOWN (871)",
	"UNKNOWN (872)",
	"UNKNOWN (873)",
	"UNKNOWN (874)",
	"UNKNOWN (875)",
	"UNKNOWN (876)",
	"UNKNOWN (877)",
	"UNKNOWN (878)",
	"UNKNOWN (879)",
	"UNKNOWN (880)",
	"UNKNOWN (881)",
	"UNKNOWN (882)",
	"UNKNOWN (883)",
	"UNKNOWN (884)",
	"UNKNOWN (885)",
	"UNKNOWN (886)",
	"UNKNOWN (887)",
	"UNKNOWN (888)",
	"UNKNOWN (889)",
	"UNKNOWN (890)",
	"UNKNOWN (891)",
	"UNKNOWN (892)",
	"UNKNOWN (893)",
	"UNKNOWN (894)",
	"WM_AFXLAST",
	"WM_PENWINFIRST",
	"UNKNOWN (897)",
	"UNKNOWN (898)",
	"UNKNOWN (899)",
	"UNKNOWN (900)",
	"UNKNOWN (901)",
	"UNKNOWN (902)",
	"UNKNOWN (903)",
	"UNKNOWN (904)",
	"UNKNOWN (905)",
	"UNKNOWN (906)",
	"UNKNOWN (907)",
	"UNKNOWN (908)",
	"UNKNOWN (909)",
	"UNKNOWN (910)",
	"WM_PENWINLAST",
	"UNKNOWN (912)",
	"UNKNOWN (913)",
	"UNKNOWN (914)",
	"UNKNOWN (915)",
	"UNKNOWN (916)",
	"UNKNOWN (917)",
	"UNKNOWN (918)",
	"UNKNOWN (919)",
	"UNKNOWN (920)",
	"UNKNOWN (921)",
	"UNKNOWN (922)",
	"UNKNOWN (923)",
	"UNKNOWN (924)",
	"UNKNOWN (925)",
	"UNKNOWN (926)",
	"UNKNOWN (927)",
	"UNKNOWN (928)",
	"UNKNOWN (929)",
	"UNKNOWN (930)",
	"UNKNOWN (931)",
	"UNKNOWN (932)",
	"UNKNOWN (933)",
	"UNKNOWN (934)",
	"UNKNOWN (935)",
	"UNKNOWN (936)",
	"UNKNOWN (937)",
	"UNKNOWN (938)",
	"UNKNOWN (939)",
	"UNKNOWN (940)",
	"UNKNOWN (941)",
	"UNKNOWN (942)",
	"UNKNOWN (943)",
	"UNKNOWN (944)",
	"UNKNOWN (945)",
	"UNKNOWN (946)",
	"UNKNOWN (947)",
	"UNKNOWN (948)",
	"UNKNOWN (949)",
	"UNKNOWN (950)",
	"UNKNOWN (951)",
	"UNKNOWN (952)",
	"UNKNOWN (953)",
	"UNKNOWN (954)",
	"UNKNOWN (955)",
	"UNKNOWN (956)",
	"UNKNOWN (957)",
	"UNKNOWN (958)",
	"UNKNOWN (959)",
	"UNKNOWN (960)",
	"UNKNOWN (961)",
	"UNKNOWN (962)",
	"UNKNOWN (963)",
	"UNKNOWN (964)",
	"UNKNOWN (965)",
	"UNKNOWN (966)",
	"UNKNOWN (967)",
	"UNKNOWN (968)",
	"UNKNOWN (969)",
	"UNKNOWN (970)",
	"UNKNOWN (971)",
	"UNKNOWN (972)",
	"UNKNOWN (973)",
	"UNKNOWN (974)",
	"UNKNOWN (975)",
	"UNKNOWN (976)",
	"UNKNOWN (977)",
	"UNKNOWN (978)",
	"UNKNOWN (979)",
	"UNKNOWN (980)",
	"UNKNOWN (981)",
	"UNKNOWN (982)",
	"UNKNOWN (983)",
	"UNKNOWN (984)",
	"UNKNOWN (985)",
	"UNKNOWN (986)",
	"UNKNOWN (987)",
	"UNKNOWN (988)",
	"UNKNOWN (989)",
	"UNKNOWN (990)",
	"UNKNOWN (991)",
	"UNKNOWN (992)",
	"UNKNOWN (993)",
	"UNKNOWN (994)",
	"UNKNOWN (995)",
	"UNKNOWN (996)",
	"UNKNOWN (997)",
	"UNKNOWN (998)",
	"UNKNOWN (999)",
	"UNKNOWN (1000)",
	"UNKNOWN (1001)",
	"UNKNOWN (1002)",
	"UNKNOWN (1003)",
	"UNKNOWN (1004)",
	"UNKNOWN (1005)",
	"UNKNOWN (1006)",
	"UNKNOWN (1007)",
	"UNKNOWN (1008)",
	"UNKNOWN (1009)",
	"UNKNOWN (1010)",
	"UNKNOWN (1011)",
	"UNKNOWN (1012)",
	"UNKNOWN (1013)",
	"UNKNOWN (1014)",
	"UNKNOWN (1015)",
	"UNKNOWN (1016)",
	"UNKNOWN (1017)",
	"UNKNOWN (1018)",
	"UNKNOWN (1019)",
	"UNKNOWN (1020)",
	"UNKNOWN (1021)",
	"UNKNOWN (1022)",
	"UNKNOWN (1023)",
	"WM_USER"
};
#endif

void Snd(int a, int b)
{
	Beep(a,b);
}

void delay(unsigned ms)
{
	Sleep(ms);
}

void sched_yield(void)
{
	Sleep(0);
}

void FGWin32Driver::SetDDerror(const char *function, int code)
{
	static char *error;
	static char  errbuf[128];

	errbuf[0] = 0;
	switch (code) {
		case DDERR_GENERIC:
			error = "Undefined error!";
			break;
		case DDERR_EXCEPTION:
			error = "Exception encountered";
			break;
		case DDERR_INVALIDOBJECT:
			error = "Invalid object";
			break;
		case DDERR_INVALIDPARAMS:
			error = "Invalid parameters";
			break;
		case DDERR_NOTFOUND:
			error = "Object not found";
			break;
		case DDERR_INVALIDRECT:
			error = "Invalid rectangle";
			break;
		case DDERR_INVALIDCAPS:
			error = "Invalid caps member";
			break;
		case DDERR_INVALIDPIXELFORMAT:
			error = "Invalid pixel format";
			break;
		case DDERR_OUTOFMEMORY:
			error = "Out of memory";
			break;
		case DDERR_OUTOFVIDEOMEMORY:
			error = "Out of video memory";
			break;
		case DDERR_SURFACEBUSY:
			error = "Surface busy";
			break;
		case DDERR_SURFACELOST:
			error = "Surface was lost";
			break;
		case DDERR_WASSTILLDRAWING:
			error = "DirectDraw is still drawing";
			break;
		case DDERR_INVALIDSURFACETYPE:
			error = "Invalid surface type";
			break;
		case DDERR_NOEXCLUSIVEMODE:
			error = "Not in exclusive access mode";
			break;
		case DDERR_NOPALETTEATTACHED:
			error = "No palette attached";
			break;
		case DDERR_NOPALETTEHW:
			error = "No palette hardware";
			break;
		case DDERR_NOT8BITCOLOR:
			error = "Not 8-bit color";
			break;
		case DDERR_EXCLUSIVEMODEALREADYSET:
			error = "Exclusive mode was already set";
			break;
		case DDERR_HWNDALREADYSET:
			error = "Window handle already set";
			break;
		case DDERR_HWNDSUBCLASSED:
			error = "Window handle is subclassed";
			break;
		case DDERR_NOBLTHW:
			error = "No blit hardware";
			break;
		case DDERR_IMPLICITLYCREATED:
			error = "Surface was implicitly created";
			break;
		case DDERR_INCOMPATIBLEPRIMARY:
			error = "Incompatible primary surface";
			break;
		case DDERR_NOCOOPERATIVELEVELSET:
			error = "No cooperative level set";
			break;
		case DDERR_NODIRECTDRAWHW:
			error = "No DirectDraw hardware";
			break;
		case DDERR_NOEMULATION:
			error = "No emulation available";
			break;
		case DDERR_NOFLIPHW:
			error = "No flip hardware";
			break;
		case DDERR_NOTFLIPPABLE:
			error = "Surface not flippable";
			break;
		case DDERR_PRIMARYSURFACEALREADYEXISTS:
			error = "Primary surface already exists";
			break;
		case DDERR_UNSUPPORTEDMODE:
			error = "Unsupported mode";
			break;
		case DDERR_WRONGMODE:
			error = "Surface created in different mode";
			break;
		case DDERR_UNSUPPORTED:
			error = "Operation not supported";
			break;
		case E_NOINTERFACE:
			error = "Interface not present";
			break;
		default:
			printf("%s: Unknown DirectDraw error: 0x%x\n", function, code);
			break;
	}
	if ( !errbuf[0] )
		printf("%s: %s\n", function, error);
	return;
}

/* The special DX5 event handler */
long FGWin32Driver::HandleMessage(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg)
	{
		case WM_SYSCOMMAND:
		{
			if ((wParam&0xFFF0)==SC_SCREENSAVE ||
				(wParam&0xFFF0)==SC_MONITORPOWER)
				return(0);
		}
	}
	return(DefWindowProc(hwnd, msg, wParam, lParam));
}

long CALLBACK WindowProc(HWND wnd, UINT message, WPARAM wparam, LPARAM lparam);

FGWin32Driver::FGWin32Driver(char *name) : FGDriver(name)
{
   char fname[1024];
//   HWND wnd;
   WNDCLASS wnd_class;

   /* setup the window class */
   wnd_class.style = CS_HREDRAW | CS_VREDRAW;
   wnd_class.lpfnWndProc = WindowProc;
   wnd_class.cbClsExtra = 0;
   wnd_class.cbWndExtra = 0;
   wnd_class.hInstance = hInstance;
   wnd_class.hIcon = LoadIcon(NULL, IDI_APPLICATION);
   wnd_class.hCursor = LoadCursor(NULL, IDC_ARROW);
   wnd_class.hbrBackground = GetStockObject(BLACK_BRUSH);
   wnd_class.lpszMenuName = NULL;
   wnd_class.lpszClassName = FG_WND_CLASS;

   RegisterClass(&wnd_class);

   /* create the window now */
   wnd = CreateWindowEx(WS_EX_APPWINDOW, FG_WND_CLASS, "OpenGUI",
        WS_SYSMENU | WS_CAPTION | WS_MINIMIZEBOX,
		0, 0,
		GetSystemMetrics( SM_CXSCREEN ),
		GetSystemMetrics( SM_CYSCREEN ),
		0,
		0,
        hInstance, NULL);
        
   if (!wnd)
   {
    	printf("CreateWindowEx() failed (%x)\n", GetLastError());
		assert(0);
   }

	islinear = 1;
	palette_8=1;
	accel_name = "DirectX";
	vector_mouse_cursor = win_cursor;
}

FGWin32DXDriver::FGWin32DXDriver(char *NAME) : FGWin32Driver("DirectX5")
{
/*
	static WNDCLASS     wc;
	hInstance = GetModuleHandle(NULL);
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = WindowProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hIcon = LoadIcon((HINSTANCE)hInstance,IDI_APPLICATION);
	wc.hCursor = LoadCursor( NULL, IDC_ARROW );
	wc.hbrBackground = NULL;
	wc.lpszMenuName = NAME;
	wc.lpszClassName = NAME;
	RegisterClass( &wc );

	hwnd = CreateWindowEx(
		WS_EX_TOPMOST,
		NAME,
		"OpenGUI",
		WS_POPUP,
		0, 0,
		GetSystemMetrics( SM_CXSCREEN ),
		GetSystemMetrics( SM_CYSCREEN ),
		0,
		0,
		(HINSTANCE)hInstance,
		0);
*/
	primary = secondary = 0;
//	ShowWindow( hwnd, SW_SHOW );
//	UpdateWindow( hwnd );
}

FGWin32DXDriver::~FGWin32DXDriver()
{
	/* Free any palettes we used */
	if ( palette != NULL )
	{
		palette->Release();
		palette = NULL;
	}

	if( ddraw2 != NULL )
	{
		// secondary
		if( secondary != NULL )
		{
			secondary->Release();
			secondary = NULL;
		}
		if( primary != NULL )
		{
			primary->Release();
			primary = 0;
		}
		ddraw2->Release();
		ddraw2 = 0;
	}
	DX5_Unload();
	DestroyWindow( wnd );
}

void FGWin32Driver::DX5_Unload(void)
{
	if ( DDrawDLL != 0 ) {
		delete DDrawDLL;
		dDrawCreate = 0;
		DDrawDLL = 0;
	}
}

int FGWin32Driver::DX5_Load(void)
{
	int status;

	DX5_Unload();
	DDrawDLL = new Dll("DDRAW.DLL");
	if ( DDrawDLL != 0 ) {
		dDrawCreate = (tDrawCreate)DDrawDLL->GetAddr("DirectDrawCreate");
	}
	if ( DDrawDLL && dDrawCreate) {
		status = 0;
	} else {
		DX5_Unload();
		status = -1;
	}
	return status;
}

int FGWin32Driver::DX5_UpdateVideoInfo(void)
{
	/* This needs to be DDCAPS_DX5 for the DirectDraw2 interface */
#if DIRECTDRAW_VERSION <= 0x300
#error Your version of DirectX must be greater than or equal to 5.0
#else
	DDCAPS_DX5 DDCaps;
#endif
	HRESULT result;

	/* Fill in our hardware acceleration capabilities */
	memset(&DDCaps, 0, sizeof(DDCaps));
	DDCaps.dwSize = sizeof(DDCaps);
	result = IDirectDraw2_GetCaps(ddraw2, (DDCAPS *)&DDCaps, NULL);
	if ( result != DD_OK )
	{
		SetDDerror("DirectDraw2::GetCaps", result);
		return(0);
	}
	/* Find out how much video memory is available */
	DDSCAPS ddsCaps;
	ddsCaps.dwCaps = DDSCAPS_VIDEOMEMORY;
	result = ddraw2->GetAvailableVidMem(&ddsCaps, &linear_size, NULL);
	if ( result != DD_OK )
	{
		linear_size = DDCaps.dwVidMemTotal;
	}
	return 1;
}

HRESULT WINAPI FGWin32DXDriver::EnumModes2(DDSURFACEDESC *desc, VOID *udata)
{
	FGWin32DXDriver *ptr = (FGWin32DXDriver *)udata;
	int _bpp = desc->ddpfPixelFormat.dwRGBBitCount;

	if(FASTGL_BPP==_bpp)
	{
		ptr->modelist[ptr->total_modes].flag = FG_LINEAR;
		ptr->modelist[ptr->total_modes].refresh = 0;
		ptr->modelist[ptr->total_modes].w = desc->dwWidth;
		ptr->modelist[ptr->total_modes].h = desc->dwHeight;
		ptr->modelist[ptr->total_modes].mode = ptr->total_modes;
		ptr->total_modes++;
	}
	return(DDENUMRET_OK);
}

int	FGWin32Driver::link(void)
{
	HRESULT result;

	/* Intialize everything */
	ddraw2 = NULL;
	palette = NULL;
	DDrawDLL = 0;
	DX5_Load();

	// Create the DirectDraw object - old
	LPDIRECTDRAW ddraw;
	result = dDrawCreate(NULL, &ddraw, NULL);
	if ( result != DD_OK ) {
		SetDDerror("DirectDrawCreate", result);
		return(0);
	}
	result = IDirectDraw_QueryInterface(ddraw, IID_IDirectDraw2,
							(LPVOID *)&ddraw2);
	IDirectDraw_Release(ddraw);
	if ( result != DD_OK ) {
		SetDDerror("DirectDraw::QueryInterface", result);
		return(0);
	}

	/* Fill in the video hardware capabilities */
	return DX5_UpdateVideoInfo();
}

int FGWin32DXDriver::set_mode(int ww, int hh)
{
	int result, Pitch;
	req_w = ww;
	req_h = hh;

	FGDriver::set_mode(ww,hh);
	if ((mode_num = find(req_w, req_h)) == -1) return 0;

	ddraw2->SetCooperativeLevel( wnd, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN | DDSCL_ALLOWREBOOT);
	ddraw2->SetDisplayMode(req_w, req_h, FASTGL_BPP, 0, 0);
	DX5_UpdateVideoInfo();

	//primary surface
	memset(&desc,0,sizeof(desc));
	desc.dwSize = sizeof(desc);
	desc.dwFlags = DDSD_BACKBUFFERCOUNT | DDSD_CAPS;
	desc.dwBackBufferCount = 1;
	desc.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE | DDSCAPS_FLIP | DDSCAPS_COMPLEX|DDSCAPS_VIDEOMEMORY;

	if (primary==0)
		ddraw2->CreateSurface(&desc,&primary,0);
	current = primary;
	//backbuffer surface
//	ddscaps.dwCaps = DDSCAPS_BACKBUFFER | DDSCAPS_FLIP | DDSCAPS_VIDEOMEMORY;
	ddscaps.dwCaps = DDSCAPS_BACKBUFFER | DDSCAPS_FLIP;
	if ((primary->GetAttachedSurface(&ddscaps,&secondary))!=DD_OK) secondary = 0;

	if (SUCCEEDED(primary->Lock(NULL,&desc,	DDLOCK_NOSYSLOCK|DDLOCK_WAIT,NULL)))
	{
		videobase = (FGPixel *)desc.lpSurface;
		Pitch = desc.lPitch;
		primary->Unlock(NULL);
	}
	else
	{
		printf("can't lock framebuffer - exiting\n");
        delete this;
        exit(0);
		return 0;
	}

#ifdef INDEX_COLORS
	char pal[1024], *p=pal;
	for(int i=0;i<256;i++)
	{
		*p++ = i;
		*p++ = i;
		*p++ = i;
		*p++ = i;
	}
	result = ddraw2->CreatePalette((DDPCAPS_8BIT|DDPCAPS_ALLOW256),
					(PALETTEENTRY *)pal,
					&palette,
					0);
	if ( result != DD_OK )
	{
		SetDDerror("DirectDraw2::CreatePalette", result);
		;
		return 0;
	}
	result = IDirectDrawSurface3_SetPalette(primary, palette);
	if ( result != DD_OK )
	{
		SetDDerror("DirectDrawSurface3::SetPalette", result);
		return 0;
	}
#endif

	ShowWindow(wnd, SW_SHOW);
	SetForegroundWindow(wnd);
	UpdateWindow(wnd);

	virt_w = Pitch/bpp;
	virt_h = req_h;
	synch = desc.dwRefreshRate;
	postinit();
	pitch = Pitch;
	ops = 8; // fillrect | mouse
	// temporary disabled - problems with DX8 and nVidia
	if (noaccel==0)
	{
//		vector_fill_box = fillbox;
//		ops |= 1;
	}
#ifdef INDEX_COLORS
	vector_palette   = dx_palette;
#endif
	return TRUE;
}

int adjust_window(HWND wnd, int w, int h)
{
	int last_wnd_x=0, last_wnd_y=0;
	RECT win_size = {last_wnd_x, last_wnd_y, last_wnd_x+w, last_wnd_y+h };

      /* retrieve the size of the decorated window */
//      AdjustWindowRect(&win_size, GetWindowLong(wnd, GWL_STYLE), FALSE);

      /* display the window */
      MoveWindow(wnd, win_size.left, win_size.top,
                 win_size.right - win_size.left, win_size.bottom - win_size.top, TRUE);

      /* check that the actual window size is the one requested */
      GetClientRect(wnd, &win_size);
      if (((win_size.right - win_size.left) != w) || ((win_size.bottom - win_size.top) != h))
         return -1;

//      wnd_x = last_wnd_x;
//      wnd_y = last_wnd_y;
//      wnd_width = w;
//      wnd_height = h;
	return 0;
}

int FGWin32GDIDriver::set_mode(int ww, int hh)
{
	int result, Pitch;
	req_w = ww;
	req_h = hh;

	FGDriver::set_mode(ww,hh);
	result = ddraw2->SetCooperativeLevel( wnd, DDSCL_NORMAL);

   	if (!(SUCCEEDED(result)))
    {
       	SetDDerror("SetCooperativeLevel", result);
//         exit(0);
    }
	DX5_UpdateVideoInfo();

    adjust_window(wnd,ww,hh);

	//primary surface
	memset(&desc,0,sizeof(desc));
	desc.dwSize = sizeof(desc);
	desc.dwFlags = DDSD_CAPS;
    desc.ddsCaps.dwCaps = DDSCAPS_SYSTEMMEMORY | DDSCAPS_OFFSCREENPLAIN;
    desc.dwFlags |= DDSD_HEIGHT | DDSD_WIDTH;
    desc.dwHeight = hh;
    desc.dwWidth = ww;
	if (primary==0)
    {
    	int err = ddraw2->CreateSurface(&desc,&primary,0);
    	if (!(SUCCEEDED(err)))
        {
        	SetDDerror("CreateSurface", err);
//            exit(0);
        }
    }

	current = primary;

	if (SUCCEEDED(primary->Lock(NULL,&desc,	DDLOCK_NOSYSLOCK|DDLOCK_WAIT,NULL)))
	{
		videobase = (FGPixel *)desc.lpSurface;
		Pitch = desc.lPitch;
		primary->Unlock(NULL);
	}
	else
	{
		printf("can't lock framebuffer - exiting\n");
        delete this;
        exit(0);
//		return 0;
	}

#ifdef INDEX_COLORS
	char pal[1024], *p=pal;
	for(int i=0;i<256;i++)
	{
		*p++ = i;
		*p++ = i;
		*p++ = i;
		*p++ = i;
	}
	result = ddraw2->CreatePalette((DDPCAPS_8BIT|DDPCAPS_ALLOW256),
					(PALETTEENTRY *)pal,
					&palette,
					0);
	if ( result != DD_OK )
	{
		SetDDerror("DirectDraw2::CreatePalette", result);
		return 0;
	}
	result = IDirectDrawSurface3_SetPalette(primary, palette);
	if ( result != DD_OK )
	{
		SetDDerror("DirectDrawSurface3::SetPalette", result);
		return 0;
	}
#endif

	memset(videobase,0,4*w*h);
	ShowWindow(wnd, SW_SHOW);
	SetForegroundWindow(wnd);
	UpdateWindow(wnd);

	virt_w = Pitch/bpp;
	virt_h = req_h;
	synch = desc.dwRefreshRate;
	postinit();
	pitch = Pitch;
	ops = 8; // fillrect | mouse
	// temporary disabled - problems with DX8 and nVidia
	if (noaccel==0)
	{
//		vector_fill_box = fillbox;
//		ops |= 1;
	}
#ifdef INDEX_COLORS
	vector_palette   = dx_palette;
#endif
	return TRUE;
}

int FGWin32Driver::get_event(int& type, int& key, int& x, int& y, int& buttons)
{
	MSG msg;
	static unsigned but=0,mx=0,my=0;
	if( PeekMessage( &msg, wnd, 0, 0, PM_NOREMOVE ) )
	{
		if( !GetMessage( &msg, NULL, 0, 0 ) )
		{
			key = ALT_X;
			type = KEYEVENT;
			return 1;
		}
		if (!TranslateMessage(&msg))
			DispatchMessage(&msg);
		switch(msg.message)
		{
			case WM_KEYDOWN:
				if (msg.lParam&0x01000000)
				{
					msg.wParam += 0x100; // sys key
					goto klavesa;
				}
				else switch(char(msg.lParam>>16))
				{
					case 0x3b: // F1
					case 0x3c:
					case 0x3d:
					case 0x3e:
					case 0x3f:
					case 0x40:
					case 0x41:
					case 0x42:
					case 0x43: // F9
					case 0x44: // F9
					case 0x57: // F11
					case 0x58: // F12
						msg.wParam += 0x200; // sys key
						goto klavesa;
				}
				break; // ordinary key
			case WM_SYSCHAR:
				if (msg.lParam&0x20000000)
				{
					msg.wParam += 0x1000; // ALT+key
				}
			case WM_CHAR:
klavesa:
				key = msg.wParam;
				type = KEYEVENT;
//gprintf(0,0,"%skey %x, %08X\n",msg.message==WM_SYSCHAR?"SYS":"", key,msg.lParam);
				return 1;

			case WM_LBUTTONDOWN:
				but |= FG_BUTTON_LEFT;
				goto mouse;
			case WM_LBUTTONUP:
				but &= ~FG_BUTTON_LEFT;
				goto mouse;
			case WM_MBUTTONDOWN:
				but |= FG_BUTTON_MIDDLE;
				goto mouse;
			case WM_MBUTTONUP:
				but &= ~FG_BUTTON_MIDDLE;
				goto mouse;
			case WM_RBUTTONDOWN:
				but |= FG_BUTTON_RIGHT;
				goto mouse;
			case WM_RBUTTONUP:
				but &= ~FG_BUTTON_RIGHT;
				goto mouse;
			case WM_MOUSEMOVE:
				mx = LOWORD(msg.lParam);  // horizontal position of cursor
				my = HIWORD(msg.lParam);  // vertical position of cursor
mouse:
				buttons = but;
				x = mx;
				y = my;
				type = MOUSEEVENT;
				return 1;
		}
		return 0;
	}
	return 0;
}

int FGWin32DXDriver::EnableBuffering(int mode)
{
	DDSURFACEDESC desc;
//	int result;
	int i;

	memset(&desc,0,sizeof(desc));
	desc.dwSize = sizeof(desc);

	// initiate
	buffer[0] = buffer[1] = buffer[2] = buffer[3] = videobase;
	// double-buffering
	bufnum = FGWin32DXDriver::desc.dwBackBufferCount+1;
	current_buffer = 0;

	// first buffer is primary/hw surface
	primary->Flip(0, DDFLIP_WAIT );

	// now we enums backfuffers ...
	for(i=0; i< bufnum; i++)
	{
		if (SUCCEEDED(secondary->Lock(NULL,&desc, DDLOCK_NOSYSLOCK|DDLOCK_WAIT,NULL)))
		{
			buffer[i] = (FGPixel *)desc.lpSurface;
			secondary->Unlock(NULL);
		}
		else printf("lock error\n");
		primary->Flip(0, DDFLIP_WAIT );
	}
	current = secondary;
	return bufnum = i;
}

int FGWin32DXDriver::set_page(int page)
{
	int result = primary->Flip(secondary, DDFLIP_WAIT);
	delay(1);
	if (result!=DD_OK)
	{
		SetDDerror("DirectDrawSurface::Flip", result);
		return 0;
	}
	return 1;
}

// ----------------------------------------------------------------

FGWin32GDIDriver::FGWin32GDIDriver(char *name) : FGWin32Driver(name)
{
	static WNDCLASS     wc;

	hInstance = GetModuleHandle(NULL);
	/*
	 * set up and register window class
	 */
	wc.style = CS_HREDRAW | CS_VREDRAW
    	| CS_BYTEALIGNCLIENT | CS_OWNDC;
	wc.lpfnWndProc = WindowProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hIcon =
	LoadIcon((HINSTANCE)hInstance,IDI_APPLICATION);
	wc.hCursor = LoadCursor( NULL, IDC_ARROW );
	wc.hbrBackground = 0;
	wc.lpszMenuName = name;
	wc.lpszClassName = name;
	RegisterClass( &wc );
}

FGWin32GDIDriver::~FGWin32GDIDriver()
{
}


/* The main Win32 event handler */
long CALLBACK WindowProc(HWND wnd, UINT message, WPARAM wparam, LPARAM lparam)
{
#ifdef WMMSG_DEBUG
	printf("Received windows message:  ");
	printf("%s", wmtab[message]);
	printf(" -- 0x%X, 0x%X\n", wParam, lParam);
#endif
   PAINTSTRUCT ps;

   switch (message) {

      case WM_CREATE:
//         if (!user_wnd_proc)  allegro_wnd = wnd;
         break;

      case WM_DESTROY:
      case WM_CLOSE:
         PostQuitMessage(0);
         break;

      case WM_SETCURSOR:
			SetCursor(LoadCursor( NULL, IDC_ARROW ));
         break;

      case WM_ACTIVATE:
         break;

      case WM_TIMER:
         break;

      case WM_ENTERSIZEMOVE:
//         if (win_gfx_driver && win_gfx_driver->enter_sysmode)
//            win_gfx_driver->enter_sysmode();
         break;

      case WM_EXITSIZEMOVE:
//         if (win_gfx_driver && win_gfx_driver->exit_sysmode)
//            win_gfx_driver->exit_sysmode();
         break;

      case WM_MOVE:
/*         if (GetActiveWindow() == allegro_wnd)
         {
            if (!IsIconic(allegro_wnd)) {
               wnd_x = (short) LOWORD(lparam);
               wnd_y = (short) HIWORD(lparam);

               if (win_gfx_driver && win_gfx_driver->move)
                  win_gfx_driver->move(wnd_x, wnd_y, wnd_width, wnd_height);
            }
            else if (win_gfx_driver && win_gfx_driver->iconify) {
               win_gfx_driver->iconify();
            }
         }
*/         break;

      case WM_SIZE:
//         wnd_width = LOWORD(lparam);
//         wnd_height = HIWORD(lparam);
         break;

      case WM_ERASEBKGND:
         /* Disable the default background eraser in order
          * to prevent conflicts on NT kernels.
          */
//         if (!user_wnd_proc || win_gfx_driver)
            return 1;
         break;

      case WM_PAINT:
            BeginPaint(wnd, &ps);
//            win_gfx_driver->paint(&ps.rcPaint);
            EndPaint(wnd, &ps);
            return 0;

      case WM_KEYDOWN:
      case WM_KEYUP:
      case WM_SYSKEYDOWN:
      case WM_SYSKEYUP:
         /* Disable the default message-based key handler
          * in order to prevent conflicts on NT kernels.
          */
            return 0;

      case WM_INITMENUPOPUP:
/*         wnd_sysmenu = TRUE;
         mouse_set_sysmenu(TRUE);

         if (win_gfx_driver && win_gfx_driver->enter_sysmode)
            win_gfx_driver->enter_sysmode();
*/         break;

      case WM_MENUSELECT:
/*         if ((HIWORD(wparam) == 0xFFFF) && (!lparam)) {
            wnd_sysmenu = FALSE;
            mouse_set_sysmenu(FALSE);

            if (win_gfx_driver && win_gfx_driver->exit_sysmode)
               win_gfx_driver->exit_sysmode();
         }
*/         break;
   }

   return DefWindowProc(wnd, message, wparam, lparam);
}



/* directx_wnd_proc:
 *  Window procedure for the Allegro window class.
 */
//static LRESULT CALLBACK directx_wnd_proc(HWND wnd, UINT message, WPARAM wparam, LPARAM lparam)
//{
//}


